<template>
    <div>
        <label :for="fieldname">{{ label }}</label>
        <br>
        <select v-model="newValue" :id="fieldname" v-on:change="changeValueInDatabase" :disabled="disabled">
            <option v-if="nullable" :value="null"></option>
            <option v-for="item in items" :value="item[itemValue]">{{ item[itemText] }}</option>
        </select>
        <broject-database-fieldchanger
            :classname="classname"
            :entity-id="entityId"
            :fieldname="fieldname"
            :old-value="oldValue"
            :new-value="newValue"
            :disabled="disabled"
            :is-changing="isChanging"
            type="select"
            @changeSucceeded="changeValueInVue"
            @changeFailed="handleFailedFieldChange"
        ></broject-database-fieldchanger>
    </div>
</template>

<script>
    import General from './General.vue';

    export default {

        extends: General,

        props: {
            items: {
                type: Array,
                required: true,
            },

            itemText: {
                type: String,
                required: true,
            },

            itemValue: {
                type: String,
                required: true,
            },

            nullable: {
                type: Boolean,
                default: false,
            },

            value: {
                type: Number,
                default: null,
            }
        }

    }
</script>
